/************various useful macros*********************/
#define  bit_test(var, bit)   ((var) & (1 <<(bit)))
#define  bit_set(var, bit)	((var) |= (1 << (bit)))
#define  bit_clear(var, bit)	((var) &= ~(1 << (bit)))
#define  nop()	asm(" nop")
#define  clrwdt()	asm(" clrwdt")
#define  sleep()	asm(" sleep")
#define TRUE	1
#define FALSE	0

/*****************************************************/

typedef struct {
        unsigned char   b0;
        unsigned char	b1;
        unsigned char	b2;
        unsigned char	b3;
}       ulng;
typedef struct {
        unsigned int	lsi;
        unsigned int	msi;
}       ulng_ints;
// TMR1 and CCPR2 can be seen as uint
static volatile unsigned int	TMR1	@ 0x0E;
static volatile unsigned int	CCPR2	@ 0x1B;

unsigned char tmr0ext; // TMR0 extension
 // a byte for keeping various flags
unsigned char STARE;
#define IMAGE_OK 0	// =1 data is prepared for displaying
#define SET_LINE	1 // =1 calibration mode
#define MIRROR	2	// =1 MIROR mode
#define EFFECT	3	// =1 is time for the next step of an effect
#define NEWDATA 4 // =1 there is new data to display (the display mode changed)
#define EFECT_BLOCK	5 // =1 PAUSE
#define MIRA	6 // =1 display the curent RPM mode
#define PC_COMM 7 // =1 PC communication for a new show download

unsigned char setted_line;

unsigned char count; // TMR1 extension
unsigned long period; // the measured period of rotation (in TMR1 clocks)
#define period_b0   (((ulng *)&period)->b0) // LSB
#define period_b1   (((ulng *)&period)->b1)
#define period_b2   (((ulng *)&period)->b2)
#define period_b3   (((ulng *)&period)->b3) // MSB

#define period_msi	(((ulng_ints *)&period)->msi)

unsigned char pixel_deg;  // pixel time (in pulses)
unsigned long ini_deg; // the angle for begining of new pixel
unsigned char current_pix,current_line; // current pixel number, current line number (as a walking 1 - a mask)

unsigned char PORTBM; // PORTB Mirror
unsigned char portb_mirror,ex_portb;
#define DOWN	4
#define UP		5
#define MODE	6
#define SHIFT	7


#define ANGLE	27 // opening angle is 27 degrees
#define NR_PIXELI 120UL // number of pixels diplayed in the opening angle
#define NR_CARS	(NR_PIXELI/6) // number of characters is NR_PIXELI/6
#if(NR_PIXELI%6)
	#error The resulting characters number is not integer!! Please modify NR_PIXELI!
#endif
/*the divider used to calculate the PIXEL*/
#define DIVIDER ((NR_PIXELI*360UL)/ANGLE)
#if((NR_PIXELI*360)%ANGLE)
	#error DIVIDER must be integer!! Please modify NR_PIXELI or ANGLE!
#endif

bank1 unsigned char disp_mirror[NR_CARS+2]; // the character buffer for display
/************this is the display buffer**************/
#if NR_PIXELI<=84
	bank2 unsigned char ldimage1[(NR_PIXELI+2+6)];
#else
	bank2 unsigned char ldimage1[96];
	bank3 unsigned char ldimage2[(NR_PIXELI-96+2+6)];
#endif
/************************************/
/*the string containig all messages to be displayed*/
extern const unsigned char   show[];       // Don't declare the size here
/*the characters map*/
const unsigned char char_map[96][5]={0,0,0,0,0, //					space
									0x00,0x00,0xf2,0x00,0x00, //	!
									0x00,0xe0,0x00,0xe0,0x00, //	"
									0x28,0xfe,0x28,0xfe,0x28, //	#
									0x24,0x54,0xfe,0x54,0x48, //	$
									0xc4,0xc8,0x10,0x26,0x46, //	%
									0x6c,0x92,0xaa,0x44,0x0a, //	&
									0x00,0xa0,0xc0,0x00,0x00, //	'
									0x00,0x38,0x44,0x82,0x00, //	(
									0x00,0x82,0x44,0x38,0x00, //	)
									0x28,0x10,0x7c,0x10,0x28, //	*
									0x10,0x10,0x7c,0x10,0x10, //	+
									0x00,0x0a,0x0c,0x00,0x00, //	,
									0x10,0x10,0x10,0x10,0x10, //	-
									0x00,0x06,0x06,0x00,0x00, //	.
									0x04,0x08,0x10,0x20,0x40, //	/
									0x7c,0x8a,0x92,0xa2,0x7c, //	0
									0x00,0x42,0xfe,0x02,0x00, //	1
									0x42,0x86,0x8a,0x92,0x62, //	2
									0x84,0x82,0xa2,0xd2,0x8c, //	3
									0x18,0x28,0x48,0xfe,0x08, //	4
									0xe4,0xa2,0xa2,0xa2,0x9c, //	5
									0x3c,0x52,0x92,0x92,0x0c, //	6
									0x80,0x8e,0x90,0xa0,0xc0, //	7
									0x6c,0x92,0x92,0x92,0x6c, //	8
									0x60,0x92,0x92,0x94,0x78, //	9
									0x00,0x6c,0x6c,0x00,0x00, //	:
									0x00,0x6a,0x6c,0x00,0x00, //	;
									0x10,0x28,0x44,0x82,0x00, //	<
									0x28,0x28,0x28,0x28,0x28, //	=
									0x00,0x82,0x44,0x28,0x10, //	>
									0x40,0x80,0x8a,0x90,0x60, //	?
									0x4c,0x92,0x9e,0x82,0x7c, //	@
									0x7e,0x88,0x88,0x88,0x7e, //	A
									0xfe,0x92,0x92,0x92,0x6c, //	B
									0x7c,0x82,0x82,0x82,0x44, //	C
									0xfe,0x82,0x82,0x44,0x38, //	D
									0xfe,0x92,0x92,0x92,0x82, //	E
									0xfe,0x90,0x90,0x90,0x80, //	F
									0x7c,0x82,0x92,0x92,0x5e, //	G
									0xfe,0x10,0x10,0x10,0xfe, //	H
									0x00,0x82,0xfe,0x82,0x00, //	I
									0x04,0x02,0x82,0xfc,0x80, //	J
									0xfe,0x10,0x28,0x44,0x82, //	K
									0xfe,0x02,0x02,0x02,0x02, //	L
									0xfe,0x40,0x30,0x40,0xfe, //	M
									0xfe,0x20,0x10,0x08,0xfe, //	N
									0x7c,0x82,0x82,0x82,0x7c, //	O
									0xfe,0x90,0x90,0x90,0x60, //	P
									0x7c,0x82,0x8a,0x84,0x7a, //	Q
									0xfe,0x90,0x98,0x94,0x62, //	R
									0x62,0x92,0x92,0x92,0x8c, //	S
									0x80,0x80,0xfe,0x80,0x80, //	T
									0xfc,0x02,0x02,0x02,0xfc, //	U
									0xf8,0x04,0x02,0x04,0xf8, //	V
									0xfc,0x02,0x1c,0x02,0xfc, //	W
									0xc6,0x28,0x10,0x28,0xc6, //	X
									0xe0,0x10,0x0e,0x10,0xe0, //	Y
									0x86,0x8a,0x92,0xa2,0xc2, //	Z
									0x00,0xfe,0x82,0x82,0x00, //	[
									0x40,0x20,0x10,0x08,0x04, //	\
									0x00,0x82,0x82,0xfe,0x00, //	]
									0x20,0x40,0x80,0x40,0x20, //	^
									0x02,0x02,0x02,0x02,0x02, //	_
									0x00,0x80,0x40,0x20,0x00, //	`
									0x04,0x2a,0x2a,0x2a,0x1e, //	a
									0xfe,0x12,0x22,0x22,0x1c, //	b
									0x1c,0x22,0x22,0x22,0x04, //	c
									0x1c,0x22,0x22,0x12,0xfe, //	d
									0x1c,0x2a,0x2a,0x2a,0x18, //	e
									0x10,0x7e,0x90,0x80,0x40, //	f
									0x30,0x4a,0x4a,0x4a,0x7c, //	g
									0xfe,0x10,0x20,0x20,0x1e, //	h
									0x00,0x22,0xbe,0x02,0x00, //	i
									0x04,0x02,0x22,0xbc,0x00, //	j
									0xfe,0x08,0x14,0x22,0x00, //	k
									0x00,0x82,0xfe,0x02,0x00, //	l
									0x3e,0x20,0x18,0x20,0x1e, //	m
									0x3e,0x10,0x20,0x20,0x1e, //	n
									0x1c,0x22,0x22,0x22,0x1c, //	o
									0x3e,0x28,0x28,0x28,0x10, //	p
									0x10,0x28,0x28,0x18,0x3e, //	q
									0x3e,0x10,0x20,0x20,0x10, //	r
									0x12,0x2a,0x2a,0x2a,0x04, //	s
									0x20,0xfc,0x22,0x02,0x04, //	t
									0x3c,0x02,0x02,0x04,0x3e, //	u
									0x38,0x04,0x02,0x04,0x38, //	v
									0x3c,0x02,0x0c,0x02,0x3c, //	w
									0x22,0x14,0x08,0x14,0x22, //	x
									0x30,0x0a,0x0a,0x0a,0x3c, //	y
									0x22,0x26,0x2a,0x32,0x22, //	z
									0x00,0x10,0x6c,0x82,0x00, //	{
									0x00,0x00,0xfe,0x00,0x00, //	|
									0x00,0x82,0x6c,0x10,0x00, //	}
									0x40,0x80,0x40,0x20,0x40, //	~
									0x10,0x38,0x54,0x10,0x10  //	<-
									};
/*default constants for calibration*/
#asm
	psect   eedata,delta=2,abs,ovrld
	org     2100h
    db      0,0x0d,0x56,0x43,0x14,0x55,0x4b,0
#endasm

