void
putbyte(unsigned char byte) {
	/* output one byte */
	while(!TXIF)	/* set when register is empty */
		continue;
	TXREG = byte;
}

unsigned char
getbyte() {
	/* retrieve one byte */
	while(!RCIF)	/* set when register is not empty */
	{
		asm("nop");
		continue;
	}
	return RCREG;	/* RXD9 and FERR are gone now */
}

void ShowDownload(void)
{
/*
download a new show from the PC
*/
unsigned int addr;
unsigned char data;
/***END OF DECLARATIONS***/
	if(getbyte()!=0x10)
		return;
	GIE=0;
	addr=&show[0]; // get the address of the first char in the show
	do
	{
		data=getbyte(); // read the new data
		if(data==EOT) // if is end of transmissiion
			break; // exit
		FLASH_WRITE(addr,data); // write the data to the flash
		addr++;
		putbyte(ACKCOM); // send the acknowledge for the next data
	}while(TRUE);
	GIE=1;
}
