void putbyte(unsigned char byte);
unsigned char getbyte(void);
void ShowDownload(void);


#define BAUD 19200
#define FOSC 20000000L
#define NINE 0     /* Use 9bit communication? FALSE=8bit */

#define DIV232 ((int)(FOSC/(16UL * BAUD) -1))
#define HIGH_SPEED 1
#if NINE == 1
#define NINE_BITS 0x40
#else
#define NINE_BITS 0
#endif

#if HIGH_SPEED == 1
#define SPEED 0x4
#else
#define SPEED 0
#endif

/* Serial initialization */
#define InitComms() 		\
    SPBRG = DIV232;     	\
    if(OERR) CREN=0; \
	TXSTA = (SPEED|NINE_BITS|0x20);	\
	RCSTA = (NINE_BITS|0x90); \
	RCIE=1

#define INICOM	0xfe
#define ACKCOM  0xfd
#define EOT		0xfc // end of transmission

#define FLASH_WRITE(addr,value) \
	EEADR=addr; \
	EEADRH=addr >> 8; \
	EEDATH = 0x34; \
	EEDATA = value; \
	EEPGD = 1; \
	WREN=1; \
	EECON2 = 0x55;	/* write sequence... */ \
	EECON2 = 0xaa; \
	WR=1; \
	asm("nop"); \
	asm("nop");	/* wait for write to complete */ \
	WREN=0

#define FLASH_READ(addr) ((EEADR=addr),(EEADRH=addr>>8),(EEPGD=1),(RD=1),(asm("nop")),(asm("nop")),EEDATA)
